<!DOCTYPE html>
<html>

<head>
  <title> Tạo đơn hàng - dành cho Admin </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron py-4">
    <h1 class="text-center mb-5"> Create Pizza Order - For Admin </h1>
    <div class="form-group row">
      <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
      <div class="col-sm-4">
        <select id="select-sizePizza" class="form-control">
          <option value="NOT_SELECT_COMBO"> Chọn cỡ Combo (Combo size)</option>
          <option value="S"> Nhỏ</option>
          <option value="M"> Vừa</option>
          <option value="L"> Lớn</option>
        </select>
      </div>
      <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
      <div class="col-sm-4">
        <select id="select-drink" class="form-control" id="select-drink">
          <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Mã voucher</label>
      <div class="col-sm-4">
        <input id="input-voucherId" type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
      </div>
      <label class="col-sm-2 col-form-label">Loại pizza</label>
      <div class="col-sm-4">
        <select id="select-loaiPizza" class="form-control">
          <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
          <option value="Seafood"> Hải sản</option>
          <option value="Hawaii"> Ha wai </option>
          <option value="Bacon"> Thịt hun khói </option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
      <div class="col-sm-4">
        <input id="input-hoTen" type="text" class="form-control" placeholder="Họ và tên">
      </div>
      <label for="" class="col-sm-2 col-form-label">Email</label>
      <div class="col-sm-4">
        <input id="input-email" type="email" class="form-control" placeholder="Email">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Số điện thoại</label>
      <div class="col-sm-4">
        <input id="input-phone" type="text" class="form-control" placeholder="Số điện thoại">
      </div>
      <label class="col-sm-2 col-form-label">Địa chỉ</label>
      <div class="col-sm-4">
        <input id="input-address" type="text" class="form-control" placeholder="Địa chỉ">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Lời nhắn</label>
      <div class="col-sm-10">
        <textarea id="textarea-loiNhan" class="form-control" placeholder="Lời nhắn"></textarea>
      </div>
    </div>
    <div class="form-group text-right">
      <button onclick="onBtnCreateOrder()" class="btn btn-primary">Create Order</button>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    const vINDEX_LIST = "indexListView.html";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }

    //Hàm xử lý khi click nút createOrder
    function onBtnCreateOrder() {
      "use strict"
      // khai báo object order để chứa thông tin đặt hàng với 14 thuộc tính
      var vOrderobj = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVourcher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: ""
      };
      //b1: thu thập dữ liệu trên form
      thuThapDuLieuInput(vOrderobj);
      //B2: Kiểm tra dữ liệu hợp lệ
      var vDuLieuHopLe = validateData(vOrderobj);
      if (vDuLieuHopLe) {
        //B3: Gọi APi
        var vXhttp = new XMLHttpRequest();
        callAPI(vOrderobj, vXhttp);
        //B4: Xử lý thông tin
        vXhttp.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            showData(vXhttp);
          }
        }
      }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm thu thập dữ liệu trên form
    function thuThapDuLieuInput(paramOrderObj) {
      "use strict"
      var vComBoSize = document.getElementById("select-sizePizza");
      var vDrink = document.getElementById("select-drink");
      var vVoucher = document.getElementById("input-voucherId");
      var vPizzaType = document.getElementById("select-loaiPizza");
      var vHoVaTen = document.getElementById("input-hoTen");
      var vEmail = document.getElementById("input-email");
      var vPhoneNumber = document.getElementById("input-phone");
      var vAddress = document.getElementById("input-address");
      var vLoiNhan = document.getElementById("textarea-loiNhan");

      paramOrderObj.kichCo = vComBoSize.value;
      paramOrderObj.idLoaiNuocUong = vDrink.value;
      paramOrderObj.soLuongNuoc = vDrink.value;
      paramOrderObj.idVourcher = vVoucher.value.trim();
      paramOrderObj.loaiPizza = vPizzaType.value;
      paramOrderObj.hoTen = vHoVaTen.value.trim();
      paramOrderObj.email = vDrink.value.trim();
      paramOrderObj.soDienThoai = vPhoneNumber.value.trim();
      paramOrderObj.diaChi = vAddress.value.trim();
      paramOrderObj.loiNhan = vLoiNhan.value.trim();

      if (paramOrderObj.kichCo == "S") {
        paramOrderObj.duongKinh = 20;
        paramOrderObj.suon = 2;
        paramOrderObj.salad = 200;
        paramOrderObj.soLuongNuoc = 2;
        paramOrderObj.thanhTien = 150000;
      }
      else if (paramOrderObj.kichCo == "M") {
        paramOrderObj.duongKinh = 24;
        paramOrderObj.suon = 4;
        paramOrderObj.salad = 300;
        paramOrderObj.soLuongNuoc = 3;
        paramOrderObj.thanhTien = 200000;
      }
      else if (paramOrderObj.kichCo == "L") {
        paramOrderObj.duongKinh = 30;
        paramOrderObj.suon = 8;
        paramOrderObj.salad = 500;
        paramOrderObj.soLuongNuoc = 4;
        paramOrderObj.thanhTien = 250000;
      }
    }

    //Hàm kiểm tra dữ liệu input validate
    function validateData(paramOrderObj) {
      "use strict"
      if (paramOrderObj.kichCo == "NOT_SELECT_COMBO") {
        alert("Cần phải chọn Combo");
        return false;
      }
      if (paramOrderObj.idLoaiNuocUong == "NOT_SELECT_DRINK") {
        alert("Cần phải chọn Nước uống");
        return false;
      }
      if (paramOrderObj.loaiPizza == "NOT_SELECT_PIZZA") {
        alert("Cần phải chọn loại pizza");
        return false;
      }
      if (paramOrderObj.hoTen == "") {
        alert("Phải điền vào họ và tên");
        return false;
      }
      if (paramOrderObj.email == "") {
        alert("Phải điền vào Email");
        return false;
      }
      var vKiemTraEmail = validateEmailInput(paramOrderObj.email);
      if (vKiemTraEmail) {
        alert("Email không đúng định dạng");
        return false;
      }
      if (paramOrderObj.soDienThoai == "") {
        alert("Phải điền vào Số điện thoại");
        return false;
      }
      var vKiemTraSDT = validatePhoneNumber(paramOrderObj.soDienThoai);
      if (vKiemTraSDT) {
        alert("Số điện thoại không đúng");
        return false;
      }

      if (paramOrderObj.diaChi == "") {
        alert("Phải điền vào địa chỉ");
        return false;
      }
      return true;
    }

    //Hàm gọi API
    function callAPI(paramOrderObj, paramXhttp) {
      "use strict"
      paramXhttp.open("GET", vBASE_URL, true);
      paramXhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      paramXhttp.send(JSON.stringify(paramOrderObj));
      console.log(paramOrderObj);
    }

    //hàm xử lý thông tin
    function showData(paramXhttp) {
      "use strict"
      console.log(paramXhttp.responseText);
      alert("Tạo đơn hàng thành công");
      window.location.href = vINDEX_LIST;
     }

    //hàm kiểm tra Email hợp lệ
    function validateEmailInput(paramEmail) {
      var vFormatReg = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
      var vCheck = vFormatReg.test(paramEmail)
      return vCheck;
    }

    //hàm kiểm tra số đt hợp lệ
    function validatePhoneNumber(paramPhoneNumber) {
      var vFormatReg = /^\d{10}$/;
      if (paramPhoneNumber.match(vFormatReg)) {
        return true;
      }
      else {
        return false;
      }
    }

    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          console.log(vXhttp.responseText); // ghi response text ra console.log
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      // load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var bDrinkOptionElement = document.createElement("option");
        bDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        bDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(bDrinkOptionElement);
      }
    }

  </script>


</body>

</html>